"use strict";var SDPUtils={generateIdentifier:function(){return Math.random().toString(36).substr(2,10)}};SDPUtils.localCName=SDPUtils.generateIdentifier(),SDPUtils.splitLines=function(t){return t.trim().split("\n").map(function(t){return t.trim()})},SDPUtils.splitSections=function(t){return t.split("\nm=").map(function(t,e){return(0<e?"m="+t:t).trim()+"\r\n"})},SDPUtils.getDescription=function(t){t=SDPUtils.splitSections(t);return t&&t[0]},SDPUtils.getMediaSections=function(t){t=SDPUtils.splitSections(t);return t.shift(),t},SDPUtils.matchPrefix=function(t,e){return SDPUtils.splitLines(t).filter(function(t){return 0===t.indexOf(e)})},SDPUtils.parseCandidate=function(t){for(var e=(0===t.indexOf("a=candidate:")?t.substring(12):t.substring(10)).split(" "),r={foundation:e[0],component:parseInt(e[1],10),protocol:e[2].toLowerCase(),priority:parseInt(e[3],10),ip:e[4],address:e[4],port:parseInt(e[5],10),type:e[7]},s=8;s<e.length;s+=2)switch(e[s]){case"raddr":r.relatedAddress=e[s+1];break;case"rport":r.relatedPort=parseInt(e[s+1],10);break;case"tcptype":r.tcpType=e[s+1];break;case"ufrag":r.ufrag=e[s+1],r.usernameFragment=e[s+1];break;default:r[e[s]]=e[s+1]}return r},SDPUtils.writeCandidate=function(t){var e=[];e.push(t.foundation),e.push(t.component),e.push(t.protocol.toUpperCase()),e.push(t.priority),e.push(t.address||t.ip),e.push(t.port);var r=t.type;return e.push("typ"),e.push(r),"host"!==r&&t.relatedAddress&&t.relatedPort&&(e.push("raddr"),e.push(t.relatedAddress),e.push("rport"),e.push(t.relatedPort)),t.tcpType&&"tcp"===t.protocol.toLowerCase()&&(e.push("tcptype"),e.push(t.tcpType)),(t.usernameFragment||t.ufrag)&&(e.push("ufrag"),e.push(t.usernameFragment||t.ufrag)),"candidate:"+e.join(" ")},SDPUtils.parseIceOptions=function(t){return t.substr(14).split(" ")},SDPUtils.parseRtpMap=function(t){var e=t.substr(9).split(" "),t={payloadType:parseInt(e.shift(),10)},e=e[0].split("/");return t.name=e[0],t.clockRate=parseInt(e[1],10),t.channels=3===e.length?parseInt(e[2],10):1,t.numChannels=t.channels,t},SDPUtils.writeRtpMap=function(t){var e=t.payloadType;void 0!==t.preferredPayloadType&&(e=t.preferredPayloadType);var r=t.channels||t.numChannels||1;return"a=rtpmap:"+e+" "+t.name+"/"+t.clockRate+(1!==r?"/"+r:"")+"\r\n"},SDPUtils.parseExtmap=function(t){t=t.substr(9).split(" ");return{id:parseInt(t[0],10),direction:0<t[0].indexOf("/")?t[0].split("/")[1]:"sendrecv",uri:t[1]}},SDPUtils.writeExtmap=function(t){return"a=extmap:"+(t.id||t.preferredId)+(t.direction&&"sendrecv"!==t.direction?"/"+t.direction:"")+" "+t.uri+"\r\n"},SDPUtils.parseFmtp=function(t){for(var e,r={},s=t.substr(t.indexOf(" ")+1).split(";"),i=0;i<s.length;i++)r[(e=s[i].trim().split("="))[0].trim()]=e[1];return r},SDPUtils.writeFmtp=function(e){var r,t="",s=e.payloadType;return void 0!==e.preferredPayloadType&&(s=e.preferredPayloadType),e.parameters&&Object.keys(e.parameters).length&&(r=[],Object.keys(e.parameters).forEach(function(t){e.parameters[t]?r.push(t+"="+e.parameters[t]):r.push(t)}),t+="a=fmtp:"+s+" "+r.join(";")+"\r\n"),t},SDPUtils.parseRtcpFb=function(t){t=t.substr(t.indexOf(" ")+1).split(" ");return{type:t.shift(),parameter:t.join(" ")}},SDPUtils.writeRtcpFb=function(t){var e="",r=t.payloadType;return void 0!==t.preferredPayloadType&&(r=t.preferredPayloadType),t.rtcpFeedback&&t.rtcpFeedback.length&&t.rtcpFeedback.forEach(function(t){e+="a=rtcp-fb:"+r+" "+t.type+(t.parameter&&t.parameter.length?" "+t.parameter:"")+"\r\n"}),e},SDPUtils.parseSsrcMedia=function(t){var e=t.indexOf(" "),r={ssrc:parseInt(t.substr(7,e-7),10)},s=t.indexOf(":",e);return-1<s?(r.attribute=t.substr(e+1,s-e-1),r.value=t.substr(s+1)):r.attribute=t.substr(e+1),r},SDPUtils.parseSsrcGroup=function(t){t=t.substr(13).split(" ");return{semantics:t.shift(),ssrcs:t.map(function(t){return parseInt(t,10)})}},SDPUtils.getMid=function(t){t=SDPUtils.matchPrefix(t,"a=mid:")[0];if(t)return t.substr(6)},SDPUtils.parseFingerprint=function(t){t=t.substr(14).split(" ");return{algorithm:t[0].toLowerCase(),value:t[1]}},SDPUtils.getDtlsParameters=function(t,e){return{role:"auto",fingerprints:SDPUtils.matchPrefix(t+e,"a=fingerprint:").map(SDPUtils.parseFingerprint)}},SDPUtils.writeDtlsParameters=function(t,e){var r="a=setup:"+e+"\r\n";return t.fingerprints.forEach(function(t){r+="a=fingerprint:"+t.algorithm+" "+t.value+"\r\n"}),r},SDPUtils.parseCryptoLine=function(t){t=t.substr(9).split(" ");return{tag:parseInt(t[0],10),cryptoSuite:t[1],keyParams:t[2],sessionParams:t.slice(3)}},SDPUtils.writeCryptoLine=function(t){return"a=crypto:"+t.tag+" "+t.cryptoSuite+" "+("object"==typeof t.keyParams?SDPUtils.writeCryptoKeyParams(t.keyParams):t.keyParams)+(t.sessionParams?" "+t.sessionParams.join(" "):"")+"\r\n"},SDPUtils.parseCryptoKeyParams=function(t){if(0!==t.indexOf("inline:"))return null;t=t.substr(7).split("|");return{keyMethod:"inline",keySalt:t[0],lifeTime:t[1],mkiValue:t[2]?t[2].split(":")[0]:void 0,mkiLength:t[2]?t[2].split(":")[1]:void 0}},SDPUtils.writeCryptoKeyParams=function(t){return t.keyMethod+":"+t.keySalt+(t.lifeTime?"|"+t.lifeTime:"")+(t.mkiValue&&t.mkiLength?"|"+t.mkiValue+":"+t.mkiLength:"")},SDPUtils.getCryptoParameters=function(t,e){return SDPUtils.matchPrefix(t+e,"a=crypto:").map(SDPUtils.parseCryptoLine)},SDPUtils.getIceParameters=function(t,e){var r=SDPUtils.matchPrefix(t+e,"a=ice-ufrag:")[0],e=SDPUtils.matchPrefix(t+e,"a=ice-pwd:")[0];return r&&e?{usernameFragment:r.substr(12),password:e.substr(10)}:null},SDPUtils.writeIceParameters=function(t){return"a=ice-ufrag:"+t.usernameFragment+"\r\na=ice-pwd:"+t.password+"\r\n"},SDPUtils.parseRtpParameters=function(t){for(var e={codecs:[],headerExtensions:[],fecMechanisms:[],rtcp:[]},r=SDPUtils.splitLines(t)[0].split(" "),s=3;s<r.length;s++){var i=r[s],n=SDPUtils.matchPrefix(t,"a=rtpmap:"+i+" ")[0];if(n){var a=SDPUtils.parseRtpMap(n),n=SDPUtils.matchPrefix(t,"a=fmtp:"+i+" ");switch(a.parameters=n.length?SDPUtils.parseFmtp(n[0]):{},a.rtcpFeedback=SDPUtils.matchPrefix(t,"a=rtcp-fb:"+i+" ").map(SDPUtils.parseRtcpFb),e.codecs.push(a),a.name.toUpperCase()){case"RED":case"ULPFEC":e.fecMechanisms.push(a.name.toUpperCase())}}}return SDPUtils.matchPrefix(t,"a=extmap:").forEach(function(t){e.headerExtensions.push(SDPUtils.parseExtmap(t))}),e},SDPUtils.writeRtpDescription=function(t,e){var r="";r+="m="+t+" ",r+=0<e.codecs.length?"9":"0",r+=" UDP/TLS/RTP/SAVPF ",r+=e.codecs.map(function(t){return void 0!==t.preferredPayloadType?t.preferredPayloadType:t.payloadType}).join(" ")+"\r\n",r+="c=IN IP4 0.0.0.0\r\n",r+="a=rtcp:9 IN IP4 0.0.0.0\r\n",e.codecs.forEach(function(t){r+=SDPUtils.writeRtpMap(t),r+=SDPUtils.writeFmtp(t),r+=SDPUtils.writeRtcpFb(t)});var s=0;return e.codecs.forEach(function(t){t.maxptime>s&&(s=t.maxptime)}),0<s&&(r+="a=maxptime:"+s+"\r\n"),r+="a=rtcp-mux\r\n",e.headerExtensions&&e.headerExtensions.forEach(function(t){r+=SDPUtils.writeExtmap(t)}),r},SDPUtils.parseRtpEncodingParameters=function(t){var e,r=[],s=SDPUtils.parseRtpParameters(t),i=-1!==s.fecMechanisms.indexOf("RED"),n=-1!==s.fecMechanisms.indexOf("ULPFEC"),a=SDPUtils.matchPrefix(t,"a=ssrc:").map(function(t){return SDPUtils.parseSsrcMedia(t)}).filter(function(t){return"cname"===t.attribute}),p=0<a.length&&a[0].ssrc,a=SDPUtils.matchPrefix(t,"a=ssrc-group:FID").map(function(t){return t.substr(17).split(" ").map(function(t){return parseInt(t,10)})});0<a.length&&1<a[0].length&&a[0][0]===p&&(e=a[0][1]),s.codecs.forEach(function(t){"RTX"===t.name.toUpperCase()&&t.parameters.apt&&(t={ssrc:p,codecPayloadType:parseInt(t.parameters.apt,10)},p&&e&&(t.rtx={ssrc:e}),r.push(t),i&&((t=JSON.parse(JSON.stringify(t))).fec={ssrc:p,mechanism:n?"red+ulpfec":"red"},r.push(t)))}),0===r.length&&p&&r.push({ssrc:p});var c=SDPUtils.matchPrefix(t,"b=");return c.length&&(c=0===c[0].indexOf("b=TIAS:")?parseInt(c[0].substr(7),10):0===c[0].indexOf("b=AS:")?1e3*parseInt(c[0].substr(5),10)*.95-16e3:void 0,r.forEach(function(t){t.maxBitrate=c})),r},SDPUtils.parseRtcpParameters=function(t){var e={},r=SDPUtils.matchPrefix(t,"a=ssrc:").map(function(t){return SDPUtils.parseSsrcMedia(t)}).filter(function(t){return"cname"===t.attribute})[0];r&&(e.cname=r.value,e.ssrc=r.ssrc);r=SDPUtils.matchPrefix(t,"a=rtcp-rsize");e.reducedSize=0<r.length,e.compound=0===r.length;t=SDPUtils.matchPrefix(t,"a=rtcp-mux");return e.mux=0<t.length,e},SDPUtils.parseMsid=function(t){var e,r=SDPUtils.matchPrefix(t,"a=msid:");if(1===r.length)return{stream:(e=r[0].substr(7).split(" "))[0],track:e[1]};t=SDPUtils.matchPrefix(t,"a=ssrc:").map(function(t){return SDPUtils.parseSsrcMedia(t)}).filter(function(t){return"msid"===t.attribute});return 0<t.length?{stream:(e=t[0].value.split(" "))[0],track:e[1]}:void 0},SDPUtils.parseSctpDescription=function(t){var e,r=SDPUtils.parseMLine(t),s=SDPUtils.matchPrefix(t,"a=max-message-size:");0<s.length&&(e=parseInt(s[0].substr(19),10)),isNaN(e)&&(e=65536);s=SDPUtils.matchPrefix(t,"a=sctp-port:");if(0<s.length)return{port:parseInt(s[0].substr(12),10),protocol:r.fmt,maxMessageSize:e};if(0<SDPUtils.matchPrefix(t,"a=sctpmap:").length){t=SDPUtils.matchPrefix(t,"a=sctpmap:")[0].substr(10).split(" ");return{port:parseInt(t[0],10),protocol:t[1],maxMessageSize:e}}},SDPUtils.writeSctpDescription=function(t,e){var r=[],r="DTLS/SCTP"!==t.protocol?["m="+t.kind+" 9 "+t.protocol+" "+e.protocol+"\r\n","c=IN IP4 0.0.0.0\r\n","a=sctp-port:"+e.port+"\r\n"]:["m="+t.kind+" 9 "+t.protocol+" "+e.port+"\r\n","c=IN IP4 0.0.0.0\r\n","a=sctpmap:"+e.port+" "+e.protocol+" 65535\r\n"];return void 0!==e.maxMessageSize&&r.push("a=max-message-size:"+e.maxMessageSize+"\r\n"),r.join("")},SDPUtils.generateSessionId=function(){return Math.random().toString().substr(2,21)},SDPUtils.writeSessionBoilerplate=function(t,e,r){e=void 0!==e?e:2,t=t||SDPUtils.generateSessionId();return"v=0\r\no="+(r||"thisisadapterortc")+" "+t+" "+e+" IN IP4 127.0.0.1\r\ns=-\r\nt=0 0\r\n"},SDPUtils.writeMediaSection=function(t,e,r,s){e=SDPUtils.writeRtpDescription(t.kind,e);return e+=SDPUtils.writeIceParameters(t.iceGatherer.getLocalParameters()),e+=SDPUtils.writeDtlsParameters(t.dtlsTransport.getLocalParameters(),"offer"===r?"actpass":"active"),e+="a=mid:"+t.mid+"\r\n",t.direction?e+="a="+t.direction+"\r\n":t.rtpSender&&t.rtpReceiver?e+="a=sendrecv\r\n":t.rtpSender?e+="a=sendonly\r\n":t.rtpReceiver?e+="a=recvonly\r\n":e+="a=inactive\r\n",t.rtpSender&&(e+="a="+(s="msid:"+s.id+" "+t.rtpSender.track.id+"\r\n"),e+="a=ssrc:"+t.sendEncodingParameters[0].ssrc+" "+s,t.sendEncodingParameters[0].rtx&&(e+="a=ssrc:"+t.sendEncodingParameters[0].rtx.ssrc+" "+s,e+="a=ssrc-group:FID "+t.sendEncodingParameters[0].ssrc+" "+t.sendEncodingParameters[0].rtx.ssrc+"\r\n")),e+="a=ssrc:"+t.sendEncodingParameters[0].ssrc+" cname:"+SDPUtils.localCName+"\r\n",t.rtpSender&&t.sendEncodingParameters[0].rtx&&(e+="a=ssrc:"+t.sendEncodingParameters[0].rtx.ssrc+" cname:"+SDPUtils.localCName+"\r\n"),e},SDPUtils.getDirection=function(t,e){for(var r=SDPUtils.splitLines(t),s=0;s<r.length;s++)switch(r[s]){case"a=sendrecv":case"a=sendonly":case"a=recvonly":case"a=inactive":return r[s].substr(2)}return e?SDPUtils.getDirection(e):"sendrecv"},SDPUtils.getKind=function(t){return SDPUtils.splitLines(t)[0].split(" ")[0].substr(2)},SDPUtils.isRejected=function(t){return"0"===t.split(" ",2)[1]},SDPUtils.parseMLine=function(t){t=SDPUtils.splitLines(t)[0].substr(2).split(" ");return{kind:t[0],port:parseInt(t[1],10),protocol:t[2],fmt:t.slice(3).join(" ")}},SDPUtils.parseOLine=function(t){t=SDPUtils.matchPrefix(t,"o=")[0].substr(2).split(" ");return{username:t[0],sessionId:t[1],sessionVersion:parseInt(t[2],10),netType:t[3],addressType:t[4],address:t[5]}},SDPUtils.isValidSDP=function(t){if("string"!=typeof t||0===t.length)return!1;for(var e=SDPUtils.splitLines(t),r=0;r<e.length;r++)if(e[r].length<2||"="!==e[r].charAt(1))return!1;return!0},"object"==typeof module&&(module.exports=SDPUtils);
//# sourceMappingURL=sdp.min.js.map